/*

SSLISTAI.js

Priority-based AI for SMART TRADERS using OFF_LANES


*/

"use strict";
this.author	= "wesfire";
this.copyright	= "2018 wesfire";
this.description= "NPC, 'smart' traders at lane A, AI.";
this.version	= "0.52";
this.licence	= "CC BY-NC-SA 4.0";
this.name = "SSLI ST AI";


this.$SSLI_PA = [new Vector3D(0,0,-20000),new Vector3D(0,0,-45000),new Vector3D(0,0,-70000)];//Array of points of destination for the npc
//this.$SSLI_PA_FAR=[3];
this.$SSLI_i = 0 ;//Index of PA ARRAY
/*this.$SSLI_this ;//WORKROUND?*/
this.$SSLI_thisII;//WORKROUNDII?
this.$SSLI_iBRHC;//Injector burn rate ORIGINAL VALUE
this.$SSLI_maxSpeedOR;//Max speed of ship ORIGINAL this.ship.maxSpeed
this.$SSLI_maxThrustOR;//Max thrust of ship ORIGINAL this.ship.maxThrust
this.$SSLI_iSFOR;//Injector speed factor ORIGINAL VAL
//this.$SSLI_DBspeed;
//this.$SSLI_tt;//W//
this.$SSLI_simeofor =0;//DROP cargo if frastrated???

this.aiStarted = function() {
	var $SSLI_ai = new worldScripts["oolite-libPriorityAI"].PriorityAIController(this.ship);
        this.$SSLI_thisII = $SSLI_ai;//WORKAROUND II
        
        $SSLI_ai.setParameter("oolite_flag_sendsDistressCalls",true);
	$SSLI_ai.setParameter("oolite_flag_allowPlanetaryLanding",false);

	if (this.ship.primaryRole == "escape-capsule")
	{
		$SSLI_ai.setCommunicationsRole("escapepod");
	}
	else
	{
		$SSLI_ai.setCommunicationsRole("trader-opportunist");
	}

	$SSLI_ai.setParameter("oolite_friendlyRoles",["oolite-pirate-victim"]);

	$SSLI_ai.setPriorities([
		{
			condition: $SSLI_ai.conditionInCombat,
			behaviour: $SSLI_ai.behaviourFleeCombat
		},
		{
			condition: $SSLI_ai.conditionHostileStationNearby,
			configuration: $SSLI_ai.configurationSetDestinationToNearestStation,
		        behaviour: $SSLI_ai.behaviourLeaveVicinityOfDestination,
			reconsider: 5
		},
		{
			condition: $SSLI_ai.conditionHasSelectedStation,
			truebranch: [
				{
					condition: $SSLI_ai.conditionSelectedStationNearby,
					configuration: $SSLI_ai.configurationSetSelectedStationForDocking,
					behaviour: $SSLI_ai.behaviourDockWithStation,
					reconsider: 60
				}
			]
		},
	
                {
			condition: $SSLI_ai.conditionNearDestination,
                        truebranch: [
                       
                        {
                            configuration: this.$SSLI_paWW,
                            behaviour: $SSLI_ai.behaviourApproachDestination,
		            reconsider: 2
                        }
                        ]	
		},
                {
			condition: $SSLI_ai.conditionPlayerNearby,
                        truebranch: [
                       
                        {
                            configuration: this.$SSLI_paWW0,
                            behaviour: $SSLI_ai.behaviourApproachDestination,
		            reconsider: 1
                        }
                        ]	
		},

		{
			configuration: this.$SSLI_paWW0,
                        behaviour: $SSLI_ai.behaviourApproachDestination,//
			reconsider: 1

		}
	]);
    	
}

this.$SSLI_PAConf = function()//Set destinations array.Point 0 edge of A lane near Witchpoint.Point 1 edge of A lane near mainPLANET.Point 2 mainStation
{
    var $SSLaneIndicator_xyn = new Vector3D([0,0,1]);//xy plane normal
    var $SSLaneIndicator_mppos = system.mainPlanet.position;// mainPlanet position vector
    var $SSLaneIndicator_mspos = system.mainStation.position;//mainStation position vector
    var $SSLaneIndicator_mpms = $SSLaneIndicator_mspos.subtract($SSLaneIndicator_mppos);// Vector from mainPlanet to mainStation
    var $SSLaneIndicator_mpmsproj = $SSLaneIndicator_mpms.subtract($SSLaneIndicator_xyn.multiply($SSLaneIndicator_mpms.dot($SSLaneIndicator_xyn)));//Projection of vector mainPlanet to mainStation to xy plane
    var $SSLaneIndicator_AWspot = $SSLaneIndicator_mpmsproj.direction().multiply(75000.0);// A lane at witchpoint
    var $SSLaneIndicator_AMSspot = $SSLaneIndicator_AWspot.add(new Vector3D([0,0,$SSLaneIndicator_mppos.z]));// A lane at planet
    var $SSLaneIndicator_EWspot = $SSLaneIndicator_mpmsproj.direction().multiply(-75000.0);// E lane at witchpoint
    var $SSLaneIndicator_EMSspot = $SSLaneIndicator_AMSspot.direction().multiply(-75000.0);// E lane at planet
    var $SSLaneIndicator_CWspot = $SSLaneIndicator_AWspot.cross($SSLaneIndicator_xyn).direction().multiply(75000.0);// C lane at witchpoint
    var $SSLaneIndicator_CMSspot = $SSLaneIndicator_AMSspot.cross($SSLaneIndicator_xyn).direction().multiply(75000.0);// C lane at planet
    var $SSLaneIndicator_GWspot = $SSLaneIndicator_CWspot.direction().multiply(-75000.0);// G lane at witchpoint
    var $SSLaneIndicator_GMSspot = $SSLaneIndicator_CMSspot.direction().multiply(-75000.0);// G lane at planet
    var $SSLaneIndicator_BWspot = Vector3D.interpolate($SSLaneIndicator_AWspot, $SSLaneIndicator_CWspot, 0.5).direction().multiply(75000.0);// B lane at witchpoin
    this.$SSLI_PA[0]=$SSLaneIndicator_AWspot;
    this.$SSLI_PA[1]=$SSLaneIndicator_AMSspot.add(new Vector3D([0,0,-system.mainPlanet.radius]));
    this.$SSLI_PA[2]=$SSLaneIndicator_mspos.add(new Vector3D([2200,2200,-2200]));

}

this.$SSLI_speedConfig = function()//Speed and destination CONFIG Function
{

    var $SSLI_sR = this.ship.checkScanner(true);//Use scanner 
    var $SSLI_noTorus = false;
    //Controll destination of npc
    if( this.ship.position.distanceTo(this.$SSLI_PA[this.$SSLI_i])<=4000)
    {

        $SSLI_noTorus = true;
        this.ship.destination = this.$SSLI_PA[this.$SSLI_i];
        this.ship.desiredRange = 1500;
    }else if(this.$SSLI_i>=1 ||this.ship.position.distanceTo(this.$SSLI_PA[this.$SSLI_i])<=12500 )
    {
        this.ship.destination = this.$SSLI_PA[this.$SSLI_i];
        this.ship.desiredRange = 1500;
    }else{
        this.ship.destination = Vector3D.interpolate(this.ship.position , this.$SSLI_PA[this.$SSLI_i], 13.5);
        this.ship.desiredRange = 1500;
    } 
    //Controll of speed
    if(($SSLI_sR == null || $SSLI_sR[0] == null)&& !$SSLI_noTorus ){
        this.ship.injectorBurnRate =0.0;
        this.ship.maxThrust = this.$SSLI_maxThrustOR *32.0;//16.0;
        this.ship.thrust = this.ship.maxThrust;
        this.ship.maxSpeed = this.$SSLI_maxSpeedOR *34.0;
        this.ship.desiredSpeed = this.$SSLI_maxSpeedOR * 32.0;
        this.ship.injectorSpeedFactor =32.0;
    }
    else if(this.ship.fuel >0.8)
    {
        this.ship.maxThrust = this.$SSLI_maxThrustOR;
        this.ship.thrust = this.ship.maxThrust;
        this.ship.maxSpeed = this.$SSLI_maxSpeedOR;
        this.ship.injectorBurnRate =this.$SSLI_iBRHC;//0.25;
        this.ship.desiredSpeed = this.ship.maxSpeed * 7.0;
        this.ship.injectorSpeedFactor =this.$SSLI_iSFOR;
    }
    else
    {
        this.ship.injectorSpeedFactor = this.$SSLI_iSFOR;
        this.ship.maxThrust = this.$SSLI_maxThrustOR;
        this.ship.thrust = this.ship.maxThrust;
        this.ship.maxSpeed = this.$SSLI_maxSpeedOR;
        this.ship.injectorBurnRate =this.$SSLI_iBRHC;//0.25;
        this.ship.desiredSpeed = this.ship.maxSpeed;
    }

}

this.$SSLI_paWW0 = function()//Just call speed and dest. config
{
    /*this.$SSLI_this.*/$SSLI_speedConfig ();
}
this.$SSLI_paWW = function()
{
    //CHANGE DESTINATION INDEX TO NEXT IN ARRAY    
    if(this.ship.position.distanceTo($SSLI_PA[$SSLI_i])<=14000)
    {
        $SSLI_i++;
    }

    //IF LAST IN ARRAY SET TO MAX (length-1)
    if ($SSLI_i>=$SSLI_PA.length-1)
    {
        $SSLI_i=$SSLI_PA.length-1; 
        $SSLI_thisII.setParameter("oolite_selectedStation",system.mainStation);
    }
    
    /*this.$SSLI_this.*/$SSLI_speedConfig ();//SET SPEED and dest
}

this.shipSpawned = function()
{
    this.$SSLI_this = this;//WORK AROUND.... TODO: ship. is this in priority ai function?
    this.$SSLI_maxThrustOR = this.ship.maxThrust;// Save ORIGINAL MAX thrust of NPC ship
    this.$SSLI_maxSpeedOR = this.ship.maxSpeed;//Save ORIGINAL MAX SPEED of NPC ship
    this.$SSLI_iBRHC = this.ship.injectorBurnRate;// SAVE ORIGINAL injector burn rate of ship
    this.$SSLI_iSFOR = this.ship.injectorSpeedFactor;//Save original injector speed factor
    this.$SSLI_PAConf();//A LANE DESTINATIONS SETUP
    this.ship.destination = Vector3D.interpolate(this.ship.position , this.$SSLI_PA[this.$SSLI_i], 13.5);//Dest. far remedy for game NPC ship speed decrease on vinicity of dest
    this.ship.desiredRange = 1500;
    
    $SSLI_speedConfig ();
}

this.shipAIFrustrated = function(context)
{
    if (context.indexOf("FLEE_TARGET") !== -1){
        //TODO FIGHT AI && IF SURVIVE NEW DEST ?
        this.$SSLI_simeofor +=10;
        if(this.$SSLI_simeofor == 10)
        {
	    ship.commsMessage("Come on now!!");
        }
        else if(this.$SSLI_simeofor == 20)
        {
            ship.adjustCargo("food",3);
            var $SSLaneIndicator_dcargo = ship.dumpCargo(1,"food");
            if ($SSLaneIndicator_dcargo != null){
                $SSLaneIndicator_dcargo.setCargo("food", 1 );
            }
        }
        else if(this.$SSLI_simeofor == 30)
        {
            ship.adjustCargo("food",2);
            var $SSLaneIndicator_dcargo = ship.dumpCargo(2,"food");
            if ($SSLaneIndicator_dcargo != null){
                $SSLaneIndicator_dcargo.setCargo("food", 1 );
            }
        }
        else if(this.$SSLI_simeofor == 40)
        {
	    ship.commsMessage("Why me?");
        }
        else if(this.$SSLI_simeofor == 60)
        {
            ship.adjustCargo("gold",440.0);
            var $SSLaneIndicator_dcargo = ship.dumpCargo(1,"food");
            if ($SSLaneIndicator_dcargo != null){
                
                var $SSLI_AA = system.entitiesWithScanClass("CLASS_CARGO",ship,10000);
                
                $SSLI_AA[0].setCargo("gold", (21+(Math.floor(Math.random() * 20))) );                
            }
        }
    }
}

this.shipEnteredStationAegis = function(station)
{
     this.$SSLI_thisII.setParameter("oolite_selectedStation",station);//To triger priority condition approach station
     this.$SSLI_i = 2;//Go near station
     $SSLI_speedConfig ();
     //player.consoleMessage("...",20);//DBUG SBSM
}



