"use strict";
this.name	= "SSLaneIndicator";
this.author	= "wesfire";
this.copyright	= "2018 wesfire";
this.description= "Main script to:-calculate and display curent lane position.-set compass lane nearest spot.-spawn 'smart' traders at A lane.";
this.version	= "0.52";
this.licence	= "CC BY-NC-SA 4.0";


//internal properties, should not touch

this.$SSLI_t = [1];//null;//new Array(1); //Smart traders ship list
this.$SSLI_bb =null;//VisualEFFECT FOR COMPASS
this.$SSLI_SmartTraderExists =false;//Spawned smart trader exists
this.$SSLI_spawnCounter;//Spawn Counter(Only 1 'Smart' trader and aproximatly every 10 min)
this.$SSLI_MODE_N=0;//MODE id

//worldscript events
this.startUp = function() {
    this.$SSLI_MODE_N=0;
    this.$SSLI_spawnCounter=0.0;
}


//Equipment mode...b key
this.mode = function ()
{
    if(player.ship.equipmentStatus("EQ_ADVANCED_COMPASS") != "EQUIPMENT_OK" ||
            player.ship.equipmentStatus("EQ_SSLI") != "EQUIPMENT_OK" ){
        player.consoleMessage("..ERROR..",4);
        return -1;
    }
    this.$SSLI_MODE_N=this.$SSLI_MODE_N+1;
    if(this.$SSLI_MODE_N%5==0){
        player.consoleMessage("SSLI, MODE: Graph.     ",4);
    }
    else if(this.$SSLI_MODE_N%5==1){
        player.consoleMessage("SSLI, MODE: Lane-1 WP. ",4);
    }
    else if(this.$SSLI_MODE_N%5==2){
        player.consoleMessage("SSLI, MODE: Lane-2 SW. ",4);
    }
    else if(this.$SSLI_MODE_N%5==3){
        player.consoleMessage("SSLI, MODE: Lane-3 SP. ",4);
    }
    else if(this.$SSLI_MODE_N%5==4){
        player.consoleMessage("SSLI, MODE: Lane-A (N).",4);
    }
}

//Equipment primed and activated....
this.activated = function ()
{

    if(player.ship.equipmentStatus("EQ_ADVANCED_COMPASS") != "EQUIPMENT_OK" ||
            player.ship.equipmentStatus("EQ_SSLI") != "EQUIPMENT_OK" ){
        player.consoleMessage("..ERROR..",4);
        return -1;
    }

    var $SSLaneIndicator_ppos = player.ship.position;
    var $SSLaneIndicator_mppos = system.mainPlanet.position;
    var $SSLaneIndicator_wpos = new Vector3D([0,0,0]);
    var $SSLaneIndicator_spos = system.sun.position;
    //Calculate lanes edges not from planet-Sun centers but from 1.2*radius of planet or SUN
    var $SSLaneIndicator_mppos1 = Vector3D.interpolate($SSLaneIndicator_wpos,$SSLaneIndicator_mppos,($SSLaneIndicator_wpos.distanceTo($SSLaneIndicator_mppos)-(system.mainPlanet.radius*1.2))/($SSLaneIndicator_wpos.distanceTo($SSLaneIndicator_mppos)));
    var $SSLaneIndicator_mppos2 = Vector3D.interpolate($SSLaneIndicator_mppos,$SSLaneIndicator_spos,((system.mainPlanet.radius*1.2))/($SSLaneIndicator_mppos.distanceTo($SSLaneIndicator_spos)));
    var $SSLaneIndicator_spos2 = Vector3D.interpolate($SSLaneIndicator_spos,$SSLaneIndicator_mppos2,((system.sun.radius*1.2))/($SSLaneIndicator_spos.distanceTo($SSLaneIndicator_mppos2)));
    var $SSLaneIndicator_spos3 = Vector3D.interpolate($SSLaneIndicator_wpos,$SSLaneIndicator_spos,($SSLaneIndicator_wpos.distanceTo($SSLaneIndicator_spos)-(system.sun.radius*1.2))/($SSLaneIndicator_wpos.distanceTo($SSLaneIndicator_spos)));
//BEACON compass FUNCTIONALITY

    if (this.$SSLI_MODE_N % 5 == 0){//GUI ON COMPASS
        player.consoleMessage("SSLI GRAPH activated ...",4);
        if (this.$SSLI_bb==null)
        {
            //  log(this.name, "null");
        }
        else if(this.$SSLI_bb.isVisualEffect){
            this.$SSLI_bb.remove();
        }

    }

    else if (this.$SSLI_MODE_N % 5 == 1){//Lane-1
        player.consoleMessage("SSLI Spot 1 set ...",4);
        if (this.$SSLI_bb==null)
        {
            //  log(this.name, "null");
        }
        else if(this.$SSLI_bb.isVisualEffect){
            this.$SSLI_bb.remove();
        }
        //PROJECTION player position to lane
        var $SSLaneIndicator_CWP_spot = this.$SSLI_closestPointOnLine ($SSLaneIndicator_wpos,$SSLaneIndicator_mppos1,$SSLaneIndicator_ppos);
        // If direction same(NOT IN BETWEEN)...
        if($SSLaneIndicator_CWP_spot.subtract($SSLaneIndicator_wpos).dot($SSLaneIndicator_CWP_spot.subtract($SSLaneIndicator_mppos1)) > 0)
        {
             //...PICK nearest edge of lane
             if ($SSLaneIndicator_ppos.distanceTo($SSLaneIndicator_wpos)>$SSLaneIndicator_ppos.distanceTo($SSLaneIndicator_mppos1))
             {
                 $SSLaneIndicator_CWP_spot = $SSLaneIndicator_mppos1;
             }
             else
             {
                 $SSLaneIndicator_CWP_spot = $SSLaneIndicator_wpos;
             }
        }
        this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_beacon",$SSLaneIndicator_CWP_spot);
        this.$SSLI_bb.beaconLabel = "Lane-1";
        player.ship.compassTarget = this.$SSLI_bb;//SWITCH COMPASS
    }

    else if (this.$SSLI_MODE_N % 5 == 3){//Lane-3 SUN-PLANET
        player.consoleMessage("SSLI Spot 3 set ...",4);
        if (this.$SSLI_bb==null)
        {
            //log(this.name, "null");
        }
        else if(this.$SSLI_bb.isVisualEffect){
            this.$SSLI_bb.remove();
        }
        //PROJECTION player position to lane
        var $SSLaneIndicator_CSP_spot = this.$SSLI_closestPointOnLine ($SSLaneIndicator_spos2,$SSLaneIndicator_mppos2,$SSLaneIndicator_ppos);
        // If direction same(NOT IN BETWEEN)...
        if($SSLaneIndicator_CSP_spot.subtract($SSLaneIndicator_spos2).dot($SSLaneIndicator_CSP_spot.subtract($SSLaneIndicator_mppos2)) > 0)
        {
             //...PICK nearest edge of lane
             if ($SSLaneIndicator_ppos.distanceTo($SSLaneIndicator_spos2)>$SSLaneIndicator_ppos.distanceTo($SSLaneIndicator_mppos2))
             {
                 $SSLaneIndicator_CSP_spot = $SSLaneIndicator_mppos2;
             }
             else
             {
                 $SSLaneIndicator_CSP_spot = $SSLaneIndicator_spos2;
             }
        }
        this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_beacon",$SSLaneIndicator_CSP_spot);
        this.$SSLI_bb.beaconLabel = "Lane-3-SUN-P";
        player.ship.compassTarget = this.$SSLI_bb;//SWITCH COMPASS
    }

    else if (this.$SSLI_MODE_N % 5 == 2){//Lane-2 SUN-WITCHPOINT
        player.consoleMessage("SSLI Spot 2 set ...",4);
        if (this.$SSLI_bb==null)
        {
            //log(this.name, "null");
        }
        else if(this.$SSLI_bb.isVisualEffect){
            this.$SSLI_bb.remove();
        }
        //PROJECTION player position to lane
        var $SSLaneIndicator_CSW_spot = this.$SSLI_closestPointOnLine ($SSLaneIndicator_spos3,$SSLaneIndicator_wpos,$SSLaneIndicator_ppos);
        // If direction same(NOT IN BETWEEN)...
        if($SSLaneIndicator_CSW_spot.subtract($SSLaneIndicator_spos3).dot($SSLaneIndicator_CSW_spot.subtract($SSLaneIndicator_wpos)) > 0)
        {
             //...PICK nearest edge of lane
             if ($SSLaneIndicator_ppos.distanceTo($SSLaneIndicator_spos3)>$SSLaneIndicator_ppos.distanceTo($SSLaneIndicator_wpos))
             {
                 $SSLaneIndicator_CSW_spot = $SSLaneIndicator_wpos;
             }
             else
             {
                 $SSLaneIndicator_CSW_spot = $SSLaneIndicator_spos3;
             }
        }
        this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_beacon",$SSLaneIndicator_CSW_spot);
        this.$SSLI_bb.beaconLabel = "Lane-2-SUN-W";
        player.ship.compassTarget = this.$SSLI_bb;//SWITCH COMPASS
    }

    else if (this.$SSLI_MODE_N % 5 == 4){//Lane-A
        player.consoleMessage("SSLI Spot A set ...",4);
        if (this.$SSLI_bb==null)
        {
            //log(this.name, "null");
        }
        else if(this.$SSLI_bb.isVisualEffect){
            this.$SSLI_bb.remove();
        }
        //LANE A edges position
        var $SSLaneIndicator_xyn = new Vector3D([0,0,1]);//xy plane normal
        var $SSLaneIndicator_ACmppos = system.mainPlanet.position;// mainPlanet position vector
        var $SSLaneIndicator_ACmspos = system.mainStation.position;//mainStation position vector
        var $SSLaneIndicator_ACmpms = $SSLaneIndicator_ACmspos.subtract($SSLaneIndicator_ACmppos);// Vector from mainPlanet to mainStation
        var $SSLaneIndicator_ACmpmsproj = $SSLaneIndicator_ACmpms.subtract($SSLaneIndicator_xyn.multiply($SSLaneIndicator_ACmpms.dot($SSLaneIndicator_xyn)));//Projection of vector mainPlanet to mainStation to xy plane
        var $SSLaneIndicator_Awpos=$SSLaneIndicator_ACmpmsproj.direction().multiply(75000.0);// A lane at witchpoint;
        var $SSLaneIndicator_Amppos=$SSLaneIndicator_Awpos.add(new Vector3D([0,0,$SSLaneIndicator_mppos1.z]));// A LANE at main planet;
        //PROJECTION player position to lane
        var $SSLaneIndicator_CAWP_spot = this.$SSLI_closestPointOnLine ($SSLaneIndicator_Awpos,$SSLaneIndicator_Amppos,$SSLaneIndicator_ppos);
        // If direction same(NOT IN BETWEEN)...
        if($SSLaneIndicator_CAWP_spot.subtract($SSLaneIndicator_Awpos).dot($SSLaneIndicator_CAWP_spot.subtract($SSLaneIndicator_Amppos)) > 0)
        {
             //...PICK nearest edge of lane
             if ($SSLaneIndicator_ppos.distanceTo($SSLaneIndicator_Awpos)>$SSLaneIndicator_ppos.distanceTo($SSLaneIndicator_Amppos))
             {
                 $SSLaneIndicator_CAWP_spot = $SSLaneIndicator_Amppos;
             }
             else
             {
                 $SSLaneIndicator_CAWP_spot = $SSLaneIndicator_Awpos;
             }
        }

        this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_beacon",$SSLaneIndicator_CAWP_spot);
        this.$SSLI_bb.beaconLabel = "Lane-A (N)";
        player.ship.compassTarget = this.$SSLI_bb;//SWITCH COMPASS
    }

//MainPlanet-Witchpoint ,GUI DISPLAY and CONSOLE MESAG
    var $SSLaneIndicator_pInCMPW = this.$SSLI_closestPointOnLine ($SSLaneIndicator_wpos,$SSLaneIndicator_mppos1,$SSLaneIndicator_ppos);
    if($SSLaneIndicator_pInCMPW.z >0 && $SSLaneIndicator_pInCMPW.z < $SSLaneIndicator_mppos1.z){//witchPoint>Player<MainPlanet LANE-1
        if($SSLaneIndicator_ppos.subtract($SSLaneIndicator_pInCMPW).magnitude()<50000){
	    player.consoleMessage("In Lane-1 (WitchPoint-Main Planet) ",4);

            if(this.$SSLI_MODE_N % 5 == 0){
                this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beacon1",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-1";
                player.ship.compassTarget = this.$SSLI_bb; 
                this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
            }
            
            return 1;
        }else if($SSLaneIndicator_ppos.subtract($SSLaneIndicator_pInCMPW).magnitude()<100000){
            //Calculate angle between mainStation and playerShip vectors on xy plane
            var $SSLaneIndicator_xyn = new Vector3D([0,0,1]);//xy plane normal
            var $SSLaneIndicator_mspos = system.mainStation.position;//mainStation position vector
            var $SSLaneIndicator_mpms = $SSLaneIndicator_mspos.subtract($SSLaneIndicator_mppos);// Vector from mainPlanet to mainStation
            var $SSLaneIndicator_mpmsproj = $SSLaneIndicator_mpms.subtract($SSLaneIndicator_xyn.multiply($SSLaneIndicator_mpms.dot($SSLaneIndicator_xyn)));//Projection of vector mainPlanet to mainStation to xy plane
            var $SSLaneIndicator_pposproj = $SSLaneIndicator_ppos.subtract($SSLaneIndicator_xyn.multiply($SSLaneIndicator_ppos.dot($SSLaneIndicator_xyn)));//Projection of vector of player to xy plane
            var $SSLaneIndicator_rPMS = $SSLaneIndicator_mpmsproj.angleTo($SSLaneIndicator_pposproj);//ANgle in Radians
            //clockwise or counterclockwise angle
            var $SSLaneIndicator_crossPMS = $SSLaneIndicator_mpmsproj.cross($SSLaneIndicator_pposproj);//Cross product of projections
            var $SSLaneIndicator_cwQ = $SSLaneIndicator_crossPMS.dot($SSLaneIndicator_xyn);//Dot prod of cross and normal. >0 cw, <0 ccw.

            if ($SSLaneIndicator_rPMS<=0.3925 || ($SSLaneIndicator_mpms.x == 0 && $SSLaneIndicator_mpms.y ==0 )){
	        player.consoleMessage("In outter Lane-A (Main Planet Station) ",4);
                if(this.$SSLI_MODE_N % 5 == 0){
                    this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beaconA",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                    this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-A (N)";
                    player.ship.compassTarget = this.$SSLI_bb; 
                    this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
                }
                return 4;
            }else if ($SSLaneIndicator_rPMS>0.3925 && $SSLaneIndicator_rPMS<=1.1775){
                if ($SSLaneIndicator_cwQ<0){
		    player.consoleMessage("In outter Lane-B ",4);
         	    if(this.$SSLI_MODE_N % 5 == 0){
         	       this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beaconB",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                       this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-B";
         	       player.ship.compassTarget = this.$SSLI_bb; 
          	      this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
      		    }
                    return 5;
		}else{
		    player.consoleMessage("In outter Lane-H ",4);
                    if(this.$SSLI_MODE_N % 5 == 0){
                        this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beaconH",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                        this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-H";
                        player.ship.compassTarget = this.$SSLI_bb; 
                        this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
                    }
                    return 11;
		}
            }else if ($SSLaneIndicator_rPMS>1.1775 && $SSLaneIndicator_rPMS<=1.9625){
                if ($SSLaneIndicator_cwQ<0){
		    player.consoleMessage("In outter Lane-C ",4);
                    if(this.$SSLI_MODE_N % 5 == 0){
                        this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beaconC",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                        this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-C";
                        player.ship.compassTarget = this.$SSLI_bb; 
                        this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
                    }
                    return 6;
		}else{
		    player.consoleMessage("In outter Lane-G ",4);
                    if(this.$SSLI_MODE_N % 5 == 0){
                        this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beaconG",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                        this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-G";
                        player.ship.compassTarget = this.$SSLI_bb; 
                        this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
                    }
                    return 10;
		}
            }else if ($SSLaneIndicator_rPMS>1.9625 && $SSLaneIndicator_rPMS<=2.7475){
                if ($SSLaneIndicator_cwQ<0){
		    player.consoleMessage("In outter Lane-D ",4);
                    if(this.$SSLI_MODE_N % 5 == 0){
                        this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beaconD",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                        this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-D";
                        player.ship.compassTarget = this.$SSLI_bb; 
                        this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
                    }
                    return 7;
		}else{
		    player.consoleMessage("In outter Lane-F ",4);
                    if(this.$SSLI_MODE_N % 5 == 0){
                        this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beaconF",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                        this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-F";
                        player.ship.compassTarget = this.$SSLI_bb; 
                        this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
                    }
                    return 9;
		}
            }else if ($SSLaneIndicator_rPMS>2.7475){
                player.consoleMessage("In outter Lane-E ",4);
                if(this.$SSLI_MODE_N % 5 == 0){
                    this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beaconE",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                    this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-E";
                    player.ship.compassTarget = this.$SSLI_bb; 
                    this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
                }
                return 8;
            }
	}else{
           // player.consoleMessage("**NOT** In lane witch-mPlanet Cylinder");
	}
    }else{
        //player.consoleMessage("**OFF** lane witch-mPlanet ");
    }

//MainPlanet-SUN ,GUI DISPLAY and CONSOLE MESAG
    var $SSLaneIndicator_pInCMPS = this.$SSLI_closestPointOnLine ($SSLaneIndicator_spos2,$SSLaneIndicator_mppos2,$SSLaneIndicator_ppos);
    if($SSLaneIndicator_pInCMPS.subtract($SSLaneIndicator_mppos2).dot($SSLaneIndicator_pInCMPS.subtract($SSLaneIndicator_spos2)) <= 0){

        if($SSLaneIndicator_ppos.subtract($SSLaneIndicator_pInCMPS).magnitude()<50000){
	    player.consoleMessage("In Lane 3 SUN-MainPlanet.",4);

            if(this.$SSLI_MODE_N % 5 == 0){
                this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beacon3",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-3";
                player.ship.compassTarget = this.$SSLI_bb; 
                this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
            }
            return 3;
        }
        else{
            //player.consoleMessage("**NOT** In lane SUN-mPlanet Cylinder");
	}
    }else{
          //  player.consoleMessage("**OFF** lane SUN-mPlanet ");
    }

//WitchPoint-SUN ,GUI DISPLAY and CONSOLE MESAG
    var $SSLaneIndicator_pInCWS = this.$SSLI_closestPointOnLine ($SSLaneIndicator_spos3,$SSLaneIndicator_wpos,$SSLaneIndicator_ppos);
    if($SSLaneIndicator_pInCWS.subtract($SSLaneIndicator_wpos).dot($SSLaneIndicator_pInCWS.subtract($SSLaneIndicator_spos3)) <= 0 ){
        if($SSLaneIndicator_ppos.subtract($SSLaneIndicator_pInCWS).magnitude()<50000){
	    player.consoleMessage("In Lane 2 SUN-Witchpoint.",4);
            if(this.$SSLI_MODE_N % 5 == 0){
                this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beacon2",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
                this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Lane-2";
                player.ship.compassTarget = this.$SSLI_bb; 
                this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
            }
            return 2;
        }
        else{
            //player.consoleMessage("**NOT** In lane SUN-Witchpoint Cylinder");
	}

    }else{
        //player.consoleMessage("**OFF** lane SUN-Witchpoint ");
    }

//NO_LANE ,GUI DISPLAY and CONSOLE MESAG

    player.consoleMessage("Not in any Known Lane.",4);

    if(this.$SSLI_MODE_N % 5 == 0){
        this.$SSLI_bb = system.addVisualEffect("SSLI_EMPTYVE_GUI_beaconNL",player.ship.position.subtract(player.ship.vectorForward.multiply(2)));
        this.$SSLI_bb.beaconLabel = "SSLI GRAPH: Not In Lane";
        player.ship.compassTarget = this.$SSLI_bb; 
        this._SSLItimerComp = new Timer(this, this.$SSLI_compToNone, 1.5, -5);
    }
    return 0;
}

//Compass gui remove target
this.$SSLI_compToNone = function(){
    if (this.$SSLI_bb==null)
        {
            //  log(this.name, "null-und");
        }
    else if(this.$SSLI_bb.isVisualEffect){
            this.$SSLI_bb.remove();
        }
}

//Calculate position p projection to line of points a,b
this.$SSLI_closestPointOnLine  = function( $SSLaneIndicator_a, $SSLaneIndicator_b, $SSLaneIndicator_p ){
    var $SSLaneIndicator_ab = $SSLaneIndicator_b.subtract($SSLaneIndicator_a);
    var $SSLaneIndicator_ap = $SSLaneIndicator_p.subtract($SSLaneIndicator_a);
    var $SSLaneIndicator_result = $SSLaneIndicator_a.add(  $SSLaneIndicator_ab.multiply($SSLaneIndicator_ap.dot($SSLaneIndicator_ab)/($SSLaneIndicator_ab.dot($SSLaneIndicator_ab))));
    return $SSLaneIndicator_result;
}

//ADD random ship for 'Smart' trader and init him properly
this.$SSLI_AddSmartTraderToALane = function(pos)
{
        if (Math.random() <= 0.4){
            this.$SSLI_traderT = "[SSLI_cobra3_trader]";
        }
        else if (Math.random() <= 0.55){
            this.$SSLI_traderT = "[SSLI_cobramk1]";
        }
        else if (Math.random() <= 0.7){
            this.$SSLI_traderT = "[SSLI_python_trader]";
        }
        else if (Math.random() <= 0.76){
            this.$SSLI_traderT = "[SSLI_boa_mk2]";
        }
        else if (Math.random() <= 0.82){
            this.$SSLI_traderT = "[SSLI_boa]";
        }
        else if (Math.random() <= 0.88){
            this.$SSLI_traderT = "[SSLI_adder]";
        }
        else if (Math.random() <= 0.94){
            this.$SSLI_traderT = "[SSLI_moray]";
        }
        else {
            this.$SSLI_traderT = "[SSLI_morayMED]";
        }
	this.$SSLI_t = system.addShips(this.$SSLI_traderT,1,pos,9000);
	if (this.$SSLI_t[0])
	{
		this.$SSLI_t[0].setCargoType("SCARCE_GOODS");    
                this.$SSLI_t[0].fuel= 7.0 - this.$SSLI_NearestIDinLY();//DONE TODO Minus distance from nearest Sun system
                this.$SSLI_t[0].awardEquipment("EQ_FUEL_INJECTION");
                this.$SSLI_t[0].awardEquipment("EQ_ECM");
                this.$SSLI_t[0].awardEquipment("EQ_ESCAPE_POD");
                this.$SSLI_t[0].setAI("SSLISTAI.js");
         }
}

this.$SSLI_NearestIDinLY = function()//To calculate fuel of "Smart" Trader when spawned, assumed comes from then nearest System
{
    var $SSLI_neighA = system.info.systemsInRange();
    var $SSLI_minD =7.0;
    for (var iiii=0;iiii<$SSLI_neighA.length;iiii++){
        var $SSLI_tmpD = System.infoForSystem(system.info.galaxyID, system.info.systemID).distanceToSystem(System.infoForSystem(system.info.galaxyID, $SSLI_neighA[iiii].systemID));
        if( $SSLI_tmpD <= $SSLI_minD){
            $SSLI_minD=$SSLI_tmpD;
        }    
    }
    return $SSLI_minD;
}

this.systemWillRepopulate = function()
{
    if (Math.random() < this.$SSLI_spawnCounter && (this.$SSLI_t==null || this.$SSLI_t[0][0] === undefined))
    {
	this.$SSLI_AddSmartTraderToALane(this.$SSLI_STOLENwormholePos());
        this.$SSLI_spawnCounter =0.0;//Reset counter
        //log(this.name, ">>>>>T t:"+this.$SSLI_t+" EA_L:"+this.$SSLI_t[0].escorts.length);
    }
    else{
        //log(this.name, "<<<<<F  L:"+this.$SSLI_t[0][0]);
        if ((this.$SSLI_t==null || this.$SSLI_t[0][0] === undefined)){
            this.$SSLI_spawnCounter +=0.03;//0.45 chance in 5 min to spawn new smart trader
        }
    }
}
this.$SSLI_STOLENwormholePos = function()//Taken from Oolite default scripts......
{
	var v = Vector3D.randomDirection().multiply(2000+Math.random()*3000);
	if (v.z < 0 && Math.abs(v.x)+Math.abs(v.y) < 1000)
	{
		v.z = -v.z; // avoid collision risk with witchbuoy
	}
	return v;
}
